#include <windows.h>
#include <iostream.h>
//#include <fstream.h> 

#pragma pack( push, 1 )
typedef
struct IMGHeadTAG
{
 DWORD version;
 WORD  headerSize;
 WORD  NumberOfSamples;
 WORD  NumberOfScanlines;
 DWORD MaxXRange;
 DWORD MaxYRange;
 DWORD MaxZRange;
 DWORD XRange;
 DWORD YRange;
 DWORD ZRange;
 WORD  DataType;
 WORD  HeadID;
 WORD  ZoomFactor;
 WORD  ZGain;
 WORD  PreSampleDelay;
 WORD  PreRetraceDelay;
 WORD  PreScanLineDelay;
 WORD  PreScanRetraceDelay;
 WORD  PreFrameDelay;
 WORD  NumberOfSubSteps;
 WORD  Linearity;
 float BiasVoltage;
 float TunnelingCurrent;
 float ReferenceForce;
 char  ImageTitle[31];
 char  ImageComments[161];
} IMGHead;
#pragma pack( pop, 1 )



//===============   - ===================================
#pragma pack( push, 1 )
typedef struct {
 short tx,mx;          // number of points into one step and X-full points of meassurement
 short ty,my;          // number of points into one step and Y-full points of meassurement
 float Kx,Ky,Kz;       // coefficients moving driver to X,Y and Z directions
 char ZUnit[4];        // label of z-axis
 char XYUnit[4];       // label of scanning plane
 struct TNotification {// notification of data
  short sLenght;  // string length
  char Text[320]; // notification string
 } Note;
 char pole[98];        // rest for reserve
 char Version[64];     // version of SPM "Nanotop"
} SPMHEAD;// it's consists of 512 bytes
#pragma pack( pop, 1 )


typedef struct {
	DWORD MaxXRange;
	DWORD MaxYRange;
	DWORD MaxZRange;
	WORD Z_gain;      // Z_gain = 0 --> X1, 1 --> X5, 2 --> X25, 3 --> X125
	WORD Zoom_level;
	BYTE Chanel;
	} TD2;

extern "C"
void SaveIMG(char* fileName, WORD* data, int width, int height, TD2* pInfo);

main(int argc, char** argv)
{
	if(argc!=3)
	{	
	 cout << "Usage: spm2img.exe <filename.spm> <filename.img>" << endl;
	 return -1;
	}
	else
	{		
		SPMHEAD SPMHeader;
		WORD*   SPMData = NULL;
		HANDLE  spmHandle;
		//argv[1] = "D:\1\001.spm";

		if((spmHandle = CreateFile((LPCSTR)argv[1],
		                       GENERIC_READ,
							   FILE_SHARE_WRITE,
							   NULL,
							   OPEN_EXISTING,
							   FILE_ATTRIBUTE_NORMAL,
							   NULL))!= INVALID_HANDLE_VALUE)
		{
         cout << "Open spm file -OK !"<< endl;
		 DWORD readBytes = 0;
		 SetFilePointer(spmHandle,0,(long*)&readBytes,FILE_BEGIN);
		 ReadFile(spmHandle, (LPVOID)&SPMHeader, sizeof(SPMHEAD), &readBytes, NULL);

		 DWORD DataSize = SPMHeader.mx*SPMHeader.my;
		 SPMData = new WORD[DataSize];
		 ReadFile(spmHandle, (LPVOID) SPMData, sizeof(WORD)*DataSize, &readBytes, NULL);

		 // RESAMPLE DATAs
		 WORD minZ = 0xffff, maxZ = 0;
		 for(register DWORD i=0;i<DataSize;i++)
		 {
		  SPMData[i]=((short*)SPMData)[i]+0x7ff;

		  if(maxZ<SPMData[i]) maxZ=SPMData[i];
		  if(minZ>SPMData[i]) minZ=SPMData[i];
		 }
		 for(        i=0;i<DataSize;i++)
		  SPMData[i]=WORD( (float(0xfff)/float(maxZ-minZ))*float(SPMData[i]-minZ) );
		 //SPMData[i]-=minZ;

		 TD2 Parameters;
		 Parameters.MaxXRange=(DWORD)(SPMHeader.Kx*(SPMHeader.mx-1))*10;
		 Parameters.MaxYRange=(DWORD)(SPMHeader.Ky*(SPMHeader.my-1))*10;
		 Parameters.MaxZRange=(DWORD)(SPMHeader.Kz*(maxZ-minZ+1))*10;
		 Parameters.Chanel=1;
		 Parameters.Z_gain=0;
		 Parameters.Zoom_level=20;		 
		 
		 DWORD temp = sizeof(IMGHead);
		 SaveIMG( argv[2], SPMData, SPMHeader.mx, SPMHeader.my, &Parameters);
		}
	}
	
	return 0;
}